Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osgGA::NodeTrackerManipulator Class Reference

Inheritance diagram for osgGA::NodeTrackerManipulator:

[legend]
List of all members.

## Public Types
enum | TrackerMode { NODE_CENTER, NODE_CENTER_AND_AZIM, NODE_CENTER_AND_ROTATION }
enum | RotationMode { TRACKBALL, ELEVATION_AZIM }
## Public Member Functions
| NodeTrackerManipulator ()
virtual const char * | className () const
| return the name of the object's class type.
void | setTrackNodePath (const osg::RefNodePath &nodePath)
void | setTrackNodePath (const osg::NodePath &nodePath)
osg::RefNodePath & | getTrackNodePath ()
const osg::RefNodePath & | getTrackNodePath () const
void | setTrackNode (osg::Node *node)
osg::Node * | getTrackNode ()
const osg::Node * | getTrackNode () const
void | setTrackerMode (TrackerMode mode)
TrackerMode | getTrackerMode () const
void | setRotationMode (RotationMode mode)
RotationMode | getRotationMode () const
virtual void | setByMatrix (const osg::Matrixd &matrix)
| set the position of the matrix manipulator using a 4x4 Matrix.
virtual void | setByInverseMatrix (const osg::Matrixd &matrix)
| set the position of the matrix manipulator using a 4x4 Matrix.
virtual osg::Matrixd | getMatrix () const
| get the position of the manipulator as 4x4 Matrix.
virtual osg::Matrixd | getInverseMatrix () const
| get the position of the manipulator as a inverse matrix of the manipulator, typically used as a model view matrix.
virtual osgUtil::SceneView::FusionDistanceMode | getFusionDistanceMode () const
| Get the FusionDistanceMode.
virtual float | getFusionDistanceValue () const
| Get the FusionDistanceValue.
virtual void | setNode (osg::Node *)
| Attach a node to the manipulator.
virtual const osg::Node * | getNode () const
| Return node if attached.
virtual osg::Node * | getNode ()
| Return node if attached.
virtual void | computeHomePosition ()
| Compute the home position.
virtual void | home (const GUIEventAdapter &ea, GUIActionAdapter &us)
| Move the camera to the default position.
virtual void | init (const GUIEventAdapter &ea, GUIActionAdapter &us)
| Start/restart the manipulator.
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &us)
| handle events, return true if handled, false otherwise.
virtual void | getUsage (osg::ApplicationUsage &usage) const
| Get the keyboard and mouse usage of this manipulator.
## Protected Member Functions
virtual | ~NodeTrackerManipulator ()
bool | validateNodePath () const
void | flushMouseEventStack ()
| Reset the internal GUIEvent stack.
void | addMouseEvent (const GUIEventAdapter &ea)
| Add the current mouse GUIEvent to internal stack.
void | computeNodeWorldToLocal (osg::Matrixd &worldToLocal) const
void | computeNodeLocalToWorld (osg::Matrixd &localToWorld) const
void | computeNodeCenterAndRotation (osg::Vec3d &center, osg::Quat &rotation) const
void | computePosition (const osg::Vec3d &eye, const osg::Vec3d &lv, const osg::Vec3d &up)
bool | calcMovement ()
| For the give mouse movement calculate the movement of the camera.
void | trackball (osg::Vec3 &axis, double &angle, double p1x, double p1y, double p2x, double p2y)
double | tb_project_to_sphere (double r, double x, double y)
bool | isMouseMoving ()
| Check the speed at which the mouse is moving.
void | clampOrientation ()
## Protected Attributes
osg::ref_ptr< const GUIEventAdapter > | _ga_t1
osg::ref_ptr< const GUIEventAdapter > | _ga_t0
osg::ref_ptr< osg::Node > | _node
osg::RefNodePath | _trackNodePath
TrackerMode | _trackerMode
RotationMode | _rotationMode
bool | _thrown
osg::Quat | _nodeRotation
osg::Quat | _rotation
float | _distance

## Member Enumeration Documentation

enum osgGA::NodeTrackerManipulator::RotationMode

  | Enumeration values:
  TRACKBALL | Use a trackball style manipulation of the view direction w.r.t the tracked orientation.
  ELEVATION_AZIM | Allow the elevation and azimuth angles to be adjust w.r.t the tracked orientation.

enum osgGA::NodeTrackerManipulator::TrackerMode

  | Enumeration values:
  NODE_CENTER | Track the center of the node's bounding sphere, but not rotations of the node. For datatbases which have a CoordinateSystemNode, the orientation is kept relative the coordinate frame if the center of the node.
  NODE_CENTER_AND_AZIM | Track the center of the node's bounding sphere, and the azimuth rotation (about the z axis of the current coordinate frame). For datatbases which have a CoordinateSystemNode, the orientation is kept relative the coordinate frame if the center of the node.
  NODE_CENTER_AND_ROTATION | Tack the center of the node's bounding sphere, and the all rotations of the node.

## Constructor & Destructor Documentation

osgGA::NodeTrackerManipulator::NodeTrackerManipulator | ( |  | ) |

virtual osgGA::NodeTrackerManipulator::~NodeTrackerManipulator | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

void osgGA::NodeTrackerManipulator::addMouseEvent | ( | const GUIEventAdapter & | ea | ) | `[protected]`

| Add the current mouse GUIEvent to internal stack.

bool osgGA::NodeTrackerManipulator::calcMovement | ( |  | ) | `[protected]`

| For the give mouse movement calculate the movement of the camera. Return true is camera has moved and a redraw is required.

void osgGA::NodeTrackerManipulator::clampOrientation | ( |  | ) | `[protected]`

virtual const char* osgGA::NodeTrackerManipulator::className | ( |  | ) | const`[inline, virtual]`

| return the name of the object's class type. Must be defined by derived classes. Reimplemented from osgGA::MatrixManipulator.

virtual void osgGA::NodeTrackerManipulator::computeHomePosition | ( |  | ) | `[virtual]`

| Compute the home position. Reimplemented from osgGA::MatrixManipulator.

void osgGA::NodeTrackerManipulator::computeNodeCenterAndRotation | ( | osg::Vec3d & | center,
|  | osg::Quat & | rotation
| ) | const`[protected]`

void osgGA::NodeTrackerManipulator::computeNodeLocalToWorld | ( | osg::Matrixd & | localToWorld | ) | const`[protected]`

void osgGA::NodeTrackerManipulator::computeNodeWorldToLocal | ( | osg::Matrixd & | worldToLocal | ) | const`[protected]`

void osgGA::NodeTrackerManipulator::computePosition | ( | const osg::Vec3d & | eye,
|  | const osg::Vec3d & | lv,
|  | const osg::Vec3d & | up
| ) | `[protected]`

void osgGA::NodeTrackerManipulator::flushMouseEventStack | ( |  | ) | `[protected]`

| Reset the internal GUIEvent stack.

virtual osgUtil::SceneView::FusionDistanceMode osgGA::NodeTrackerManipulator::getFusionDistanceMode | ( |  | ) | const`[inline, virtual]`

| Get the FusionDistanceMode. Used by SceneView for setting up setereo convergence. Reimplemented from osgGA::MatrixManipulator.

virtual float osgGA::NodeTrackerManipulator::getFusionDistanceValue | ( |  | ) | const`[inline, virtual]`

| Get the FusionDistanceValue. Used by SceneView for setting up setereo convergence. Reimplemented from osgGA::MatrixManipulator.

virtual osg::Matrixd osgGA::NodeTrackerManipulator::getInverseMatrix | ( |  | ) | const`[virtual]`

| get the position of the manipulator as a inverse matrix of the manipulator, typically used as a model view matrix. Implements osgGA::MatrixManipulator.

virtual osg::Matrixd osgGA::NodeTrackerManipulator::getMatrix | ( |  | ) | const`[virtual]`

| get the position of the manipulator as 4x4 Matrix. Implements osgGA::MatrixManipulator.

virtual osg::Node* osgGA::NodeTrackerManipulator::getNode | ( |  | ) | `[virtual]`

| Return node if attached. Reimplemented from osgGA::MatrixManipulator.

virtual const osg::Node* osgGA::NodeTrackerManipulator::getNode | ( |  | ) | const`[virtual]`

| Return node if attached. Reimplemented from osgGA::MatrixManipulator.

RotationMode osgGA::NodeTrackerManipulator::getRotationMode | ( |  | ) | const`[inline]`

TrackerMode osgGA::NodeTrackerManipulator::getTrackerMode | ( |  | ) | const`[inline]`

const osg::Node* osgGA::NodeTrackerManipulator::getTrackNode | ( |  | ) | const`[inline]`

osg::Node* osgGA::NodeTrackerManipulator::getTrackNode | ( |  | ) | `[inline]`

const osg::RefNodePath& osgGA::NodeTrackerManipulator::getTrackNodePath | ( |  | ) | const`[inline]`

osg::RefNodePath& osgGA::NodeTrackerManipulator::getTrackNodePath | ( |  | ) | `[inline]`

virtual void osgGA::NodeTrackerManipulator::getUsage | ( | osg::ApplicationUsage & | usage | ) | const`[virtual]`

| Get the keyboard and mouse usage of this manipulator. Reimplemented from osgGA::GUIEventHandler.

virtual bool osgGA::NodeTrackerManipulator::handle | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | us
| ) | `[virtual]`

| handle events, return true if handled, false otherwise. Reimplemented from osgGA::MatrixManipulator.

virtual void osgGA::NodeTrackerManipulator::home | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | us
| ) | `[virtual]`

| Move the camera to the default position. May be ignored by manipulators if home functionality is not appropriate. Reimplemented from osgGA::MatrixManipulator.

virtual void osgGA::NodeTrackerManipulator::init | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | us
| ) | `[virtual]`

| Start/restart the manipulator. Reimplemented from osgGA::MatrixManipulator.

bool osgGA::NodeTrackerManipulator::isMouseMoving | ( |  | ) | `[protected]`

| Check the speed at which the mouse is moving. If speed is below a threshold then return false, otherwise return true.

virtual void osgGA::NodeTrackerManipulator::setByInverseMatrix | ( | const osg::Matrixd & | matrix | ) | `[inline, virtual]`

| set the position of the matrix manipulator using a 4x4 Matrix. Implements osgGA::MatrixManipulator.

virtual void osgGA::NodeTrackerManipulator::setByMatrix | ( | const osg::Matrixd & | matrix | ) | `[virtual]`

| set the position of the matrix manipulator using a 4x4 Matrix. Implements osgGA::MatrixManipulator.

virtual void osgGA::NodeTrackerManipulator::setNode | ( | osg::Node * |  | ) | `[virtual]`

| Attach a node to the manipulator. Automatically detaches previously attached node. setNode(NULL) detaches previously nodes. Is ignored by manipulators which do not require a reference model. Reimplemented from osgGA::MatrixManipulator.

void osgGA::NodeTrackerManipulator::setRotationMode | ( | RotationMode | mode | ) |

void osgGA::NodeTrackerManipulator::setTrackerMode | ( | TrackerMode | mode | ) |

void osgGA::NodeTrackerManipulator::setTrackNode | ( | osg::Node * | node | ) |

void osgGA::NodeTrackerManipulator::setTrackNodePath | ( | const osg::NodePath & | nodePath | ) | `[inline]`

void osgGA::NodeTrackerManipulator::setTrackNodePath | ( | const osg::RefNodePath & | nodePath | ) | `[inline]`

double osgGA::NodeTrackerManipulator::tb_project_to_sphere | ( | double | r,
|  | double | x,
|  | double | y
| ) | `[protected]`

void osgGA::NodeTrackerManipulator::trackball | ( | osg::Vec3 & | axis,
|  | double & | angle,
|  | double | p1x,
|  | double | p1y,
|  | double | p2x,
|  | double | p2y
| ) | `[protected]`

bool osgGA::NodeTrackerManipulator::validateNodePath | ( |  | ) | const`[inline, protected]`

## Member Data Documentation

float osgGA::NodeTrackerManipulator::_distance`[protected]`

osg::ref_ptr<const GUIEventAdapter> osgGA::NodeTrackerManipulator::_ga_t0`[protected]`

osg::ref_ptr<const GUIEventAdapter> osgGA::NodeTrackerManipulator::_ga_t1`[protected]`

osg::ref_ptr<osg::Node> osgGA::NodeTrackerManipulator::_node`[protected]`

osg::Quat osgGA::NodeTrackerManipulator::_nodeRotation`[protected]`

osg::Quat osgGA::NodeTrackerManipulator::_rotation`[protected]`

RotationMode osgGA::NodeTrackerManipulator::_rotationMode`[protected]`

bool osgGA::NodeTrackerManipulator::_thrown`[protected]`

TrackerMode osgGA::NodeTrackerManipulator::_trackerMode`[protected]`

osg::RefNodePath osgGA::NodeTrackerManipulator::_trackNodePath`[protected]`

The documentation for this class was generated from the following file:

- NodeTrackerManipulator